<?php

/*
InstaFEED was written by Daniele Lucchini (http://www.litterae.eu/) in June 2019. All rights reserved.
By the way, you may use for free this software, only for personal and not commercial use.
InstaFEED converts an Instagram stream into an RSS feed.
To configure InstaFEED, just set the variable $utente at line 14 with the Instagram user name to follow, and upload this file to your site.
To run InstaFEED, just call it in your web browser: e.g. www.miosito.it/instafeed.php
NB: InstaFEED takes about 10 seconds to process Instagram data, so be patient.
*/

// replace "instagram" user name with the user name you actually want to follow
// sostituisci il nome utente "instagram" dell'esempio con il nome utente che vuoi seguire
$utente = "instagram";

// RSS channel
header("Content-type: text/xml");
echo "<?xml version='1.0' encoding='UTF-8'?>
 <rss version='2.0'>
 <channel>
 <title>InstaFEED, Instagram to RSS | written by Litterae.eu</title>
 <link>https://www.litterae.eu/</link>
 <description>Profilo Instagram di $utente</description>
 <language>it-it</language>";

// read the last 12 posts (it seems that Instagram doesn't allow to process more this way)
ini_set("user_agent","InstaFEED from ".$_SERVER['SERVER_NAME']);
$user = file_get_contents('https://www.instagram.com/'.$utente.'/');
$fotografie = explode ('edge_media_to_caption',$user);
$conta = 0;
foreach(array_slice($fotografie,1) as $foto) {
    $conta = $conta + 1;
    if ($conta > 12) { break; }
    $start = strpos($foto,'"shortcode":"');
    $stop = strpos($foto,'","edge_media_to_comment"',$start);
    $codice = substr($foto,$start+13,$stop-$start-13);
    $start = strpos($foto,'"text":"');
    $stop = strpos($foto,'"}}]}',$start);
    $commento = substr($foto,$start+8,$stop-$start-8);
    $commento = str_replace("\n","",$commento);
    $start = strpos($foto,'"display_url":"');
    $stop = strpos($foto,'","edge_liked_by"',$start);
    $immagine = substr($foto,$start+15,$stop-$start-15);
    echo "<item>
    <title>$commento</title>
    <link>https://www.instagram.com/p/'.$codice</link>
    <description><![CDATA[<img src='$immagine'>]]></description>
    </item>";
}
echo "</channel></rss>";

?>
